# klosett.py

from grafikfenster import *
from math import pi,radians
from moebel import Moebel

### ---------------------------------------------------
class Klosett(Moebel):
    """Klasse Klosett
    ermoeglicht das Zeichnen und Bearbeiten eines
    Klosett-Symbols fuer den Raumplaner"""
    
    def __init__(self,
                 xPos=120,
                 yPos=120,
                 breite=40,
                 tiefe=60,
                 winkel=0,
                 farbe="lightGray",
                 fuellfarbe='transparent',
                 sichtbar=False):
        """Konstruktor mit vordefinierten Parametern
        Konstruktor der Oberklasse aufrufen!"""
        Moebel.__init__(self, xPos, yPos, breite, tiefe, winkel, farbe, fuellfarbe, sichtbar)
        if sichtbar: self.Zeige()
        
    def GibFigur(self):
        """definiert die zu zeichnende Figur"""
        path = self.GibZeichenPfad()

        # lokale Variable zur Schreibvereinfachung
        b, t = self.GibBreite(), self.GibTiefe()
        path.MoveToPoint(0, 2*t/3.0)
        path.AddLineToPoint(0, 0)
        path.AddLineToPoint(b, 0)
        path.AddLineToPoint(b, 2*t/3.0)
        path.MoveToPoint(b, 2*t/3.0)
        path.AddArc(0.5*b, 2*t/3.0, 20, 0, pi, True)
        path.AddEllipse(0.05*b, 0.35*t, 0.9*b, 0.6*t)

        return self.Transformiere(path)


### ---------------------------------------------------
class KlosettApp(wx.App):
    """Test-Anwendung speziell fuer Klosett"""
    def OnInit(self):
        self.fenster = GrafikFenster(None, "Raumplaner-Grafik")
        self.SetTopWindow(self.fenster)
        self.fenster.Show(True)
        self.fenster.panel.Refresh()
        self.fenster.ZeigeShellFrame()
        #self.fenster.ZeigeFillingFrame()
        self.TestAnwendung()
        return True

    def TestAnwendung(self):
        """Allein fuer die Testanwendung:"""
        global klosett
        klosett=Klosett(sichtbar=True)
        
### ---------------------------------------------------
if __name__ == '__main__':
    app = KlosettApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
