# sessel.py

from grafikfenster import *
from math import radians
from moebel import Moebel

### ---------------------------------------------------
class Sessel(Moebel):
    """Klasse Sessel
    ermoeglicht das Zeichnen und Bearbeiten eines
    Sessel-Symbols fuer den Raumplaner"""
    
    def __init__(self,
                 xPos=20,
                 yPos=20,
                 breite=60,
                 tiefe=60,
                 winkel=0,
                 farbe="black",
                 fuellfarbe='transparent',
                 sichtbar=False):
        """Konstruktor mit vordefinierten Parametern
        Konstruktor der Oberklasse aufrufen!"""
        Moebel.__init__(self, xPos, yPos, breite, tiefe, winkel, farbe, fuellfarbe, sichtbar)
        if sichtbar: self.Zeige()
        
    def GibFigur(self):
        """definiert die zu zeichnende Figur"""
        path = self.GibZeichenPfad()

        # lokale Variable zur Schreibvereinfachung
        b, t = self.GibBreite(), self.GibTiefe()
        path.AddRectangle(0, 0, b, t)
        path.AddRectangle(0, 0, b/6, t)
        path.AddRectangle(5*b/6, 0, b/6, t)
        path.AddRectangle(b/6, 0, 4*b/6, t/6)

        return self.Transformiere(path)


### ---------------------------------------------------
class SesselApp(wx.App):
    """Test-Anwendung speziell fuer Sessel"""
    def OnInit(self):
        self.fenster = GrafikFenster(None, "Raumplaner-Grafik")
        self.SetTopWindow(self.fenster)
        self.fenster.Show(True)
        self.fenster.panel.Refresh()
        self.fenster.ZeigeShellFrame()
        #self.fenster.ZeigeFillingFrame()
        self.TestAnwendung()
        return True

    def TestAnwendung(self):
        """Allein fuer die Testanwendung:"""
        global sessel
        sessel=Sessel(300, 10, 60, 60, 270, 'orange', True)
        
### ---------------------------------------------------
if __name__ == '__main__':
    app = SesselApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
